#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <EzGraph.h>
#include "draw.h"
#include "obj_draw.h"

#include "xpm/obj/egg.xpm"
//#include "xpm/obj/rat.xpm"
#include "xpm/obj/rat_walk0.xpm"
#include "xpm/obj/rat_walk1.xpm"
#include "xpm/obj/blank32.xpm"
#include "xpm/obj/chickpea_grow1.xpm"
#include "xpm/obj/chickpea_grow2.xpm"
#include "xpm/obj/chickpea_grow3.xpm"
#include "xpm/obj/chickpea_grow4.xpm"
#include "xpm/obj/chickpea_grow5.xpm"

static EzImage rat_walk0_img;
static EzImage rat_walk1_img;
static EzImage egg_img;
static EzImage chickpea_grow_imgs[CHICKPEA_GROW_MAX];

void obj_draw_put(int x, int y, EzImage img);

    
void obj_draw_init(void){
    egg_img = EzReadXPM(egg_xpm);
    rat_walk0_img = EzReadXPM(rat_walk0_xpm);
    rat_walk1_img = EzReadXPM(rat_walk1_xpm);
    chickpea_grow_imgs[0] = EzReadXPM(blank32_xpm);
    chickpea_grow_imgs[1] = EzReadXPM(chickpea_grow1_xpm);
    chickpea_grow_imgs[2] = EzReadXPM(chickpea_grow2_xpm);
    chickpea_grow_imgs[3] = EzReadXPM(chickpea_grow3_xpm);
    chickpea_grow_imgs[4] = EzReadXPM(chickpea_grow4_xpm);
    chickpea_grow_imgs[5] = EzReadXPM(chickpea_grow5_xpm);
        
}

void obj_draw_egg(obj_t *obj){
    //    puts("draw egg");
    obj_draw_put(obj->x, obj->y, egg_img);
    //    EzPutB((int)(obj->x)+FIELD_LX-16,
    //           (int)(obj->y)+FIELD_TY-16,
    //           egg_img);
    //    EzSetColorByRGB(255, 0, 0);
    //    EzDrawCircleB((int)(obj->x)+FIELD_LX, (int)(obj->y)+FIELD_TY, 12);
}

void obj_draw_rat(obj_t *obj){
    // 死んでいる間は描画しない
    if (obj->ctr2 > 0) return; 
    //    puts("draw rat");
    if (obj->ctr1 % 2 == 0){
        obj_draw_put(obj->x, obj->y, rat_walk0_img);
    }
    else {
        obj_draw_put(obj->x, obj->y, rat_walk1_img);
    }

    EzSetColorByRGB(0, 0, 255);
    EzDrawCircleB((int)(obj->dest_x)+FIELD_LX, (int)(obj->dest_y)+FIELD_TY, 6);
}

void obj_draw_chickpea(obj_t *obj){
    //    printf("draw chickpea ctr:(%d:%d)\n", obj->ctr1, obj->ctr2);
    obj_draw_put(obj->x, obj->y, chickpea_grow_imgs[obj->ctr2]);
}

void obj_draw_put(int x, int y, EzImage img){
    EzPutB(x+FIELD_LX-16, y+FIELD_TY-16, img);
    EzSetColorByRGB(255, 0, 0);
    EzDrawCircleB(x+FIELD_LX, y+FIELD_TY, 16);
}
