#ifndef SNAKE_H
#define SNAKE_H

#include "config.h"
#include "bin_deg.h"

typedef struct {
    double x, y;
    bin_deg_t deg;
} snake_unit_t;

typedef void (*snake_callback_t)(snake_unit_t*);


void snake_init(void);
void setup_snake_classic(int x, int y, bin_deg_t deg);
void setup_snake_uroboros(int x, int y, bin_deg_t deg);
void snake_iterator(snake_callback_t callback,
                    snake_callback_t head_callback);
void proceed_snake(bin_deg_t turn_deg);
int judge_snake_bump(void);
void set_snake_bite(void);
void reset_snake_bite(void);
void grow_snake(int count);
int is_head_overlapped(double x, double y, int dist2);
int get_snake_attack_count(void);
void get_snake_attack_pos(double *x, double *y, int *r);
void snake_attack(void);
#endif
