#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <EzGraph.h>
#include "config.h"
#include "main.h"
#include "title.h"
#include "draw.h"
#include "title_draw.h"

static title_menuitem_t cursor_pos;

void title_init(void){
    //    cursor_pos = ti_classic;
    cursor_pos = ti_uroboros;
}

void setup_title(void){
    EzSetKeyHandler(title_keyh);
    EzSetKeyReleaseHandler(title_key_releaseh);
    EzSetTimerHandler(title_timerh, GAME_SPEED);
}

void title_keyh(int key){
    switch (key){
    case EZ_Left:
    case EZ_Up:
        cursor_pos = (cursor_pos + ti_end - 1) % ti_end;
        break;
    case EZ_Right:
    case EZ_Down:
        cursor_pos = (cursor_pos + 1) % ti_end;
        break;
    default:
        break;
    }
}

void title_key_releaseh(int key){
    switch (key){
    case ' ':
    case EZ_Return:
        switch (cursor_pos){
        case ti_classic:
            set_main_state(ms_game_classic);
            break;
        case ti_uroboros:
            set_main_state(ms_game_uroboros);
            break;
        case ti_quit:
            set_main_state(ms_quit);
            break;
        default:
            assert(0);
            exit(1);
        }
    default:
        break;
    }
}

void title_timerh(void){
    draw_title();
}

title_menuitem_t get_title_cursor_pos(void){
    return cursor_pos;
}
